# frozen_string_literal: true

module Litbuild
  class LogfileNamer
    def initialize(log_dir)
      @log_dir = log_dir
      @counter = 0
    end

    def path_for(blueprint, phase = nil, stage = nil)
      count = format('%03d', @counter)
      @counter += 1
      file_name = build_name(count, blueprint, phase, stage)
      File.join(@log_dir, file_name)
    end

    protected

    def build_name(*elements)
      elements.uniq.compact.join('-') + '.log'
    end
  end
end
