# frozen_string_literal: false

require 'litbuild/visitor'

module Litbuild
  # This is a simple Visitor that just accumulates the files needed to
  # build a set of Pacakge blueprints.
  class SourceFilesVisitor < Visitor
    def initialize
      super
      @files = []
    end

    def visit_package(package:)
      @files << files_needed(package)
    end

    def files_needed(pkg)
      ["#{pkg.name_and_version}.tar"] + pkg.patch_files + pkg.in_tree_packages
    end

    def files
      @files.compact.flatten.sort.uniq
    end
  end
end
